Option Explicit
Declare Function PostMessageByString% Lib "User" Alias "PostMessage" (ByVal hWnd%, ByVal wMsg%, ByVal wParam%, ByVal lParam$)
Global Const WM_WININICHANGE = &H1A
Global Const HWND_BROADCAST = &HFFFF
Declare Function GetProfileString% Lib "Kernel" (ByVal lpAppName$, ByVal lpKeyName As Any, ByVal lpDefault$, ByVal lpReturnedString$, ByVal nSize%)
Declare Function WriteProfileString% Lib "Kernel" (ByVal lpApplicationName$, ByVal lpKeyName As Any, ByVal lpString As Any)
Declare Function GetPrivateProfileString% Lib "Kernel" (ByVal lpApplicationName$, ByVal lpKeyName As Any, ByVal lpDefault$, ByVal lpReturnedString$, ByVal nSize%, ByVal lpFileName$)
Declare Function WritePrivateProfileString% Lib "Kernel" (ByVal lpApplicationName$, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lplFileName$)
Declare Function GetWindowsDirectory% Lib "Kernel" (ByVal lpBuffer$, ByVal nSize%)

Function GetIni$ (sFile$, sSection$, sKey$)
'Declare Function GetProfileString% Lib "Kernel" (ByVal lpAppName$, ByVal lpKeyName As Any, ByVal lpDefault$, ByVal lpReturnedString$, ByVal nSize%)
'Declare Function GetPrivateProfileString% Lib "Kernel" (ByVal lpApplicationName$, ByVal lpKeyName As Any, ByVal lpDefault$, ByVal lpReturnedString$, ByVal nSize%, ByVal lpFileName$)
'Declare Function GetWindowsDirectory% Lib "Kernel" (ByVal lpBuffer$, ByVal nSize%)
Dim sWinDir$
Dim sValue$
Dim nLength%
Dim nPosition%

    If ((sFile <> "") And (Dir$(sFile) = "")) Then
        GetIni = ""
        Exit Function
    End If
    If sSection = "" Then
        GetIni = ""
        Exit Function
    End If
    sWinDir = String$(255, 0)
    sValue = String$(16384, 0)
    nLength = GetWindowsDirectory(sWinDir, 254)
    sWinDir = Left$(sWinDir, nLength)
    sFile = LCase(sFile)
    Select Case sFile
        Case LCase$(sWinDir) & "\win.ini"
            If sKey = "" Then
                nLength = GetProfileString(sSection, 0&, "", sValue, 16383)
            Else
                nLength = GetProfileString(sSection, sKey, "", sValue, 16383)
            End If
        Case ""
            If sKey = "" Then
                nLength = GetProfileString(sSection, 0&, "", sValue, 16383)
            Else
                nLength = GetProfileString(sSection, sKey, "", sValue, 16383)
            End If
        Case Else
            If sKey = "" Then
                nLength = GetPrivateProfileString(sSection, 0&, "", sValue, 16383, sFile)
            Else
                nLength = GetPrivateProfileString(sSection, sKey, "", sValue, 16383, sFile)
            End If
    End Select
    sWinDir = ""
    If nLength = 0 Then
        GetIni = ""
        Exit Function
    End If
    sValue = Left$(sValue, nLength)
    Do While InStr(sValue, Chr$(0))
        nPosition = InStr(sValue, Chr$(0))
        Mid$(sValue, nPosition, 1) = " "
    Loop
    GetIni = sValue
End Function

Sub Main ()
Dim sOperation$, sFile$, sSection$, sKey$, sValue$
    sOperation = ""
    sFile = ""
    sSection = ""
    sKey = ""
    sValue = ""
    ParseCommandLine Command$, sOperation, sFile, sSection, sKey, sValue
    If sOperation = "get" Then
        Open "ini.bat" For Output As #1
        If sKey = "" Then
            Print #1, "set %ini%" & sSection & "=" & GetIni(sFile, sSection, sKey)
        Else
            Print #1, "set %ini%" & sKey & "=" & GetIni(sFile, sSection, sKey)
        End If
        Close #1
    End If
    If sOperation = "set" Then SetIni sFile$, sSection$, sKey$, sValue$

End Sub

Sub ParseCommandLine (ByVal sCommand$, sOperation$, sFile$, sSection$, sKey$, sValue$)
Dim nStart%
Dim nEnd%

    If ((sCommand = "") Or (sCommand = "/?")) Then
        ShowHelp
        End
    End If

    'Find sValue
    nStart = InStr(sCommand, "=")
    If nStart = 0 Then
        sValue = ""
    Else
        If nStart = Len(sCommand) Then
            sValue = ""
        Else
            sValue = Mid$(sCommand, nStart + 1)
            sOperation = "set"
        End If
    End If

    'Find sKey
    nStart = InStr(sCommand, "]")
    If nStart = 0 Then
        sKey = ""
    Else
        If nStart = Len(sCommand) Then
            sKey = ""
        Else
            sKey = Mid$(sCommand, nStart + 1)
            nEnd = InStr(sKey, "=")
            If nEnd <> 0 Then sKey = Left$(sKey, nEnd - 1)
        End If
    End If

    'Find sSection
    nStart = InStr(sCommand, "[")
    If nStart = 0 Then
        sSection = ""
    Else
        sSection = Mid$(sCommand, nStart + 1)
        nEnd = InStr(sSection, "]")
        If nEnd <> 0 Then sSection = Left$(sSection, nEnd - 1)
    End If

    'Find sFile
    nStart = InStr(sCommand, Chr$(34))
    If nStart = 0 Then
        sFile = ""
    Else
        sFile = Mid$(sCommand, nStart + 1)
        nEnd = InStr(sFile, Chr$(34))
        If nEnd <> 0 Then sFile = Left$(sFile, nEnd - 1)
        If InStr(sFile, "\") = 0 Then
            If Dir$(sFile) <> "" Then
                sFile = app.Path & "\" & sFile
            End If
        End If
    End If


    'Find sOperation
    If InStr(LCase(sCommand), "/g") <> 0 Then
        If InStr(LCase(sCommand), "/g") < 2 Then sOperation = "get"
    End If
    If InStr(LCase(sCommand), "/s") <> 0 Then
        If InStr(LCase(sCommand), "/s") < 2 Then sOperation = "set"
    End If






End Sub

Sub SetIni (sFile$, sSection$, sKey$, sValue$)
'Declare Function WriteProfileString% Lib "Kernel" (ByVal lpApplicationName$, ByVal lpKeyName As Any, ByVal lpString As Any)
'Declare Function WritePrivateProfileString% Lib "Kernel" (ByVal lpApplicationName$, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lplFileName$)
'Declare Function GetWindowsDirectory% Lib "Kernel" (ByVal lpBuffer$, ByVal nSize%)
'Declare Function PostMessageByString% Lib "User" Alias "PostMessage" (ByVal hWnd%, ByVal wMsg%, ByVal wParam%, ByVal lParam$)
'Global Const WM_WININICHANGE = &H1A
'Global Const HWND_BROADCAST = &HFFFF
Dim sWinDir$
Dim nLength%
    If sSection = "" Then Exit Sub
    sWinDir = String$(255, 0)
    nLength = GetWindowsDirectory(sWinDir, 254)
    sWinDir = Left$(sWinDir, nLength)
    sFile = LCase(sFile)
    Select Case sFile
        Case LCase$(sWinDir) & "\win.ini"
            If sKey = "" Then
                nLength = WriteProfileString(sSection, 0&, sValue)
                If nLength <> 0 Then nLength = PostMessageByString(HWND_BROADCAST, WM_WININICHANGE, 0, sSection)
                Exit Sub
            End If
            If sValue = "" Then
                nLength = WriteProfileString(sSection, sKey, 0&)
                If nLength <> 0 Then nLength = PostMessageByString(HWND_BROADCAST, WM_WININICHANGE, 0, sSection)
                Exit Sub
            End If
            nLength = WriteProfileString(sSection, sKey, sValue)
            If nLength <> 0 Then nLength = PostMessageByString(HWND_BROADCAST, WM_WININICHANGE, 0, sSection)
            Exit Sub
        Case ""
            If sKey = "" Then
                nLength = WriteProfileString(sSection, 0&, sValue)
                If nLength <> 0 Then nLength = PostMessageByString(HWND_BROADCAST, WM_WININICHANGE, 0, sSection)
                Exit Sub
            End If
            If sValue = "" Then
                nLength = WriteProfileString(sSection, sKey, 0&)
                If nLength <> 0 Then nLength = PostMessageByString(HWND_BROADCAST, WM_WININICHANGE, 0, sSection)
                Exit Sub
            End If
            nLength = WriteProfileString(sSection, sKey, sValue)
            If nLength <> 0 Then nLength = PostMessageByString(HWND_BROADCAST, WM_WININICHANGE, 0, sSection)
            Exit Sub
        Case Else
            If sKey = "" Then
                nLength = WritePrivateProfileString(sSection, 0&, sValue, sFile)
                Exit Sub
            End If
            If sValue = "" Then
                nLength = WritePrivateProfileString(sSection, sKey, 0&, sFile)
                Exit Sub
            End If
            nLength = WritePrivateProfileString(sSection, sKey, sValue, sFile)
            Exit Sub
    End Select
End Sub

Sub ShowHelp ()
Dim sHelpMessage
    sHelpMessage = "Usage:" & Chr$(13) & Chr$(10)
    sHelpMessage = sHelpMessage & "INI [/get|/set] [FileName] SectionName [KeyName]=[KeyValue]" & Chr$(13) & Chr$(10)
    sHelpMessage = sHelpMessage & "FileName must be quoted." & Chr$(13) & Chr$(10)
    sHelpMessage = sHelpMessage & "If FileName is omitted, WIN.INI is assumed." & Chr$(13) & Chr$(10)
    sHelpMessage = sHelpMessage & "If WIN.INI is /set, a message will be broadcast notifying all running applications." & Chr$(13) & Chr$(10)
    sHelpMessage = sHelpMessage & "If FileName path is omitted and FileName is not in the current directory, Windows directory is assumed." & Chr$(13) & Chr$(10)
    sHelpMessage = sHelpMessage & "If /set option is used and FileName does not exist, it will be created" & Chr$(13) & Chr$(10)
    sHelpMessage = sHelpMessage & "SectionName must be in [brackets]." & Chr$(13) & Chr$(10)
    sHelpMessage = sHelpMessage & "An equal sign must separate the KeyName and KeyValue." & Chr$(13) & Chr$(10)
    sHelpMessage = sHelpMessage & "If KeyName is omitted and /set is used, all keys in the SectionName are deleted." & Chr$(13) & Chr$(10)
    sHelpMessage = sHelpMessage & "If KeyName is omitted and /get is used, all KeyNames in the SectionName will be returned." & Chr$(13) & Chr$(10)
    sHelpMessage = sHelpMessage & "If KeyValue is omitted and /set is used, the KeyName is deleted." & Chr$(13) & Chr$(10)
    sHelpMessage = sHelpMessage & "If KeyValue is supplied, /set is assumed." & Chr$(13) & Chr$(10)
    sHelpMessage = sHelpMessage & "The output of the /get operation is a batch file in the current" & Chr$(13) & Chr$(10)
    sHelpMessage = sHelpMessage & "directory named INI.BAT containing the single line:" & Chr$(13) & Chr$(10)
    sHelpMessage = sHelpMessage & "set %ini%KeyName=KeyValue" & Chr$(13) & Chr$(10)
    MsgBox sHelpMessage, 64, "Ini Command Help"
End Sub

